-- Switch a WorldMap POI to use our texture given the index
local function replace_worldmap_texture(index)
	local texture = _G["WorldMapFramePOI"..index.."Texture"]
	texture:SetTexture("Interface\\AddOns\\IOCIconFix\\POIICONS.tga")
end

-- Swich the BattlefieldMinimap POI to use our texture given the index
local function replace_battlefield_texture(index)
	local texture = _G["BattlefieldMinimapPOI"..index.."Texture"]
	texture:SetTexture("Interface\\AddOns\\IOCIconFix\\POIICONS.tga")
end

-- Secure hook switches it for all newly made POIs.
hooksecurefunc("WorldMap_CreatePOI", replace_worldmap_texture)

-- Pickup any made before we loaded.
for i=1, NUM_WORLDMAP_POIS do
	replace_worldmap_texture(i)
end

-- hook and replace any already existing BattlefieldMinimap textures
local function setup_battlefield()
		hooksecurefunc("BattlefieldMinimap_CreatePOI", replace_battlefield_texture)
		for i=1, NUM_BATTLEFIELDMAP_POIS do
			replace_battlefield_texture(i)
		end
end

-- Trap the load of the Blizzard_BattlefieldMinimap addon
local frame = CreateFrame("Frame")
frame:RegisterEvent("ADDON_LOADED")
frame:SetScript("OnEvent", function (self, event, addon)
	if addon == "Blizzard_BattlefieldMinimap" then
		setup_battlefield()
	end
end)

-- If Blizzard_BattlefieldMinimap is already loaded before us do the setup
if IsAddOnLoaded("Blizzard_BattlefieldMinimap") then
	setup_battlefield()
end

-- Minimap
Minimap:SetIconTexture("Interface\\AddOns\\IOCIconFix\\POIICONS.tga")
